##
##  javacc.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2009 OpenPKG Foundation e.V. <http://openpkg.net/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_javacc 5.0
%define       V_subdir 17/138911
%define       V_freecc 0.9.3

#   package information
Name:         javacc
Summary:      Java Compiler Compiler
URL:          http://javacc.dev.java.net/
Vendor:       Sun Microsystems
Packager:     OpenPKG Foundation e.V.
Distribution: OpenPKG Community
Class:        EVAL
Group:        CompilerCompiler
License:      BSD-style
Version:      %{V_javacc}
Release:      20090717

#   list of sources
Source0:      http://javacc.dev.java.net/files/documents/%{V_subdir}/javacc-%{V_javacc}.tar.gz
Source1:      http://freecc.googlecode.com/files/freecc-%{V_freecc}.tar.gz

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20060823
PreReq:       OpenPKG, openpkg >= 20060823, java
AutoReq:      no
AutoReqProv:  no

%description
    Java Compiler Compiler (JavaCC) is the most popular parser generator
    for use with Java applications. It reads a grammar specification
    and converts it to a Java program that can recognize matches to the
    grammar. In addition to the parser generator itself, JavaCC provides
    other standard capabilities related to parser generation such as
    tree building (via a tool called JJTree included with JavaCC),
    actions, debugging, etc. This package also contains the FreeCC fork
    of JavaCC which comes as a single program and provides additional
    features.

%track
    prog javacc:javacc = {
        version   = %{V_subdir}.%{V_javacc}
        url       = http://javacc.dev.java.net/servlets/ProjectDocumentList
        regex     = /files/documents/(\d+\/\d+/javacc-__VER__)\.tar\.gz
        transform = "s/^(.+)\/javacc-(.+)$/$1.$2/; $_"
    }
    prog javacc:freecc = {
        version   = %{V_freecc}
        url       = http://code.google.com/p/freecc/
        regex     = freecc-(__VER__)\.tar\.gz
    }

%prep
    %setup -q
    %setup -q -T -D -a 1

%build
    for tool in javacc jjdoc jjtree; do
        ( echo "#!/bin/sh"
          echo "exec %{l_prefix}/bin/java \\%{l_nil}"
          echo "    -cp %{l_prefix}/libexec/javacc/javacc.jar \\%{l_nil}"
          echo "    $tool \${1+\"\$@\"}"
        ) >$tool
    done
    ( echo "#!/bin/sh"
      echo "exec %{l_prefix}/bin/java \\%{l_nil}"
      echo "    -cp %{l_prefix}/libexec/javacc/freecc.jar:%{l_prefix}/libexec/javacc/freemarker.jar \\%{l_nil}"
      echo "    org.visigoths.freecc.Main \${1+\"\$@\"}"
    ) >freecc

%install
    rm -rf $RPM_BUILD_ROOT
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/javacc \
        $RPM_BUILD_ROOT%{l_prefix}/share/javacc
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        javacc jjdoc jjtree freecc \
        $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 644 \
        bin/lib/javacc.jar \
        freecc-*/bin/freecc.jar \
        freecc-*/bin/freemarker.jar \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/javacc/
    cp -rp doc/* $RPM_BUILD_ROOT%{l_prefix}/share/javacc/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

